%undefine _missing_build_ids_terminate_build
%global main_ver 3.0

Summary:       GNU Ubiquitous Intelligent Language for Extensions
Name:          guile
Version:       3.0.9
Release:       3%{?dist}
License:       LGPLv3+ and MIT and Public Domain and GPL+ and GPLv3+
URL:           https://www.gnu.org/software/guile/
Source:        https://ftp.gnu.org/gnu/guile/guile-%{version}.tar.gz

BuildRequires: make gcc autoconf  pkgconfig libtool libtool-ltdl-devel
BuildRequires: pkgconfig(gmp) pkgconfig(readline) pkgconfig(libffi) pkgconfig(bdw-gc)
BuildRequires: gettext-devel libunistring-devel
Requires:      coreutils
Requires(post): info
Requires(preun): info
Provides:      bundled(gnulib)

%description
Guile is an implementation of the Scheme programming language,
supporting the Revised5 and most of the Revised6 language reports,
as well as many SRFIs.
Guile contains an efficient compiler and virtual machine.
It can be used out of the box to write programs in Scheme, or can easily
be integrated with C and C++ programs.
Guile is designed to help programmers create flexible applications that
can be extended by users or other programmers with plug-ins, modules, or scripts.


%package devel
Summary:       Libraries and header files for guile extensibility library
Requires:      guile = %{version}-%{release}
Requires:      pkgconfig pkgconfig(gmp) pkgconfig(bdw-gc)

%description devel
Libraries and header files to develop applications with guile extensibility library.


%prep
%autosetup -n %{name}-%{version}
#The two testcases arr not stable, so disable
echo exit 77 > test-suite/standalone/test-stack-overflow
echo exit 77 > test-suite/standalone/test-out-of-memory


%build
autoreconf -fiv
%configure --disable-static \
           --disable-error-on-warning \
           --program-suffix=%{main_ver}

%make_build


%install
%make_install
rm -f %{buildroot}%{_infodir}/dir
find %{buildroot}%{_libdir} -type f -name "*.la" -delete
#for slib
mkdir -p %{buildroot}%{_datadir}/guile/site/%{main_ver}
mkdir -p %{buildroot}%{_datadir}/guile/%{main_ver}
mv %{buildroot}%{_libdir}/libguile*-gdb.scm %{buildroot}%{_datadir}/guile/%{main_ver}

for i in $(seq 1 11); do
  mv %{buildroot}%{_infodir}/guile{,-%{main_ver}}.info-$i
  sed -i -e 's/guile\.info/guile-%{main_ver}.info/' %{buildroot}%{_infodir}/guile-%{main_ver}.info-$i
  sed -i -e 's/\* Guile Reference: (guile)/* Guile %{main_ver} Reference: (guile-%{main_ver})/' %{buildroot}%{_infodir}/guile-%{main_ver}.info-$i
done
mv %{buildroot}%{_infodir}/guile{,-%{main_ver}}.info
sed -i -e 's/guile\.info/guile-%{main_ver}.info/' %{buildroot}%{_infodir}/guile-%{main_ver}.info
sed -i -e 's/\* Guile Reference: (guile)/* Guile %{main_ver} Reference: (guile-%{main_ver})/' %{buildroot}%{_infodir}/guile-%{main_ver}.info
mv %{buildroot}%{_infodir}/r5rs{,-%{main_ver}}.info
mv %{buildroot}%{_datadir}/aclocal/guile{,-%{main_ver}}.m4



%check
%make_build check


%post
install-info %{_infodir}/guile-%{main_ver}.info.gz %{_infodir}/dir
for i in $(seq 1 11); do
  install-info %{_infodir}/guile-%{main_ver}.info-$i.gz %{_infodir}/dir
done
install-info %{_infodir}/r5rs-%{main_ver}.info.gz %{_infodir}/dir 

%preun
install-info --delete %{_infodir}/guile-%{main_ver}.info.gz %{_infodir}/dir
for i in $(seq 1 11); do
  install-info --delete %{_infodir}/guile-%{main_ver}.info-$i.gz %{_infodir}/dir
done
install-info --delete %{_infodir}/r5rs-%{main_ver}.info.gz %{_infodir}/dir 


%files
%license COPYING COPYING.LESSER LICENSE
%doc AUTHORS HACKING README THANKS
%{_bindir}/guild%{main_ver}
%{_bindir}/guile%{main_ver}
%{_bindir}/guile-tools%{main_ver}
%{_libdir}/guile
%{_libdir}/libguile-%{main_ver}.so.1*
%dir %{_datadir}/guile
%dir %{_datadir}/guile/site
%dir %{_datadir}/guile/site/%{main_ver}
%dir %{_datadir}/guile/%{main_ver}
%dir %{_datadir}/guile/%{main_ver}/scheme
%{_datadir}/guile/%{main_ver}/*
%{_infodir}/*
%{_mandir}/man1/guile%{?main_ver}*

%files devel
%{_bindir}/guile-config%{?main_ver}
%{_bindir}/guile-snarf%{?main_ver}
%{_datadir}/aclocal/*
%{_libdir}/libguile-%{main_ver}.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/guile


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.9-3
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.9-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 Shuo Wang <abushwang@tencent.com> - 3.0.9-1
- update to 3.0.9

* Thu Aug 17 2023 Shuo Wang <abushwang@tencent.com> - 3.0.8-4
- Rebuilt for libunistring 1.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.8-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.8-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jul 25 2022 rockerzhu <rockerzhu@tencent.com> - 3.0.8-1
- Initial build
